/*+------------------------------------------------------------------
  Portable Pixmap class header file

  Clifford M. Bryant, Jr.
*/

#include <stdlib.h>
#include <stdio.h>

typedef struct _tagRGB
{
	unsigned char red;
	unsigned char green;
	unsigned char blue;
} SRGB;

class CPPM
{
public:
	CPPM();
	~CPPM();
	void ppmRead(const char * szFileName);
	int ppmGetWidth() { return m_iWidth; }
	int ppmGetHeight() { return m_iHeight; }
	unsigned char * ppmGetImage() { return reinterpret_cast<unsigned char *>(m_prgbImage); }
	enum { BUFFSIZE = 256 };

private:
	void ppmReadHeaderLine(FILE * fin, char * buff);
	void ppmFlipImage();
	void ppmCycleImage();

	int m_iWidth;			// image width
	int m_iHeight;			// image height
	int m_iColorMax;		// maximum value per color channel
	SRGB * m_prgbImage;		// image in row major format (RGB values)
};